Index: trunk/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- trunk/source/Lib/TLibCommon/TypeDef.h	(revision 81)
+++ trunk/source/Lib/TLibCommon/TypeDef.h	(revision 100)
@@ -42,21 +42,57 @@
 //! \{
 
+#define FIXES                           1
+#define LGE_EDGE_INTRA                  1       //JCT2-A0070
+#if LGE_EDGE_INTRA
+#define LGE_EDGE_INTRA_MIN_SIZE         4
+#define LGE_EDGE_INTRA_MAX_SIZE        32
+#define LGE_EDGE_INTRA_THRESHOLD       20
+#define LGE_EDGE_INTRA_MAX_EDGE_NUM_PER_4x4 8
+#define LGE_EDGE_INTRA_DELTA_DC         1 
+#define LGE_EDGE_INTRA_PIXEL_DIFFERENCE 1
+#endif
+
+#define LG_ZEROINTRADEPTHRESI_M26039      1  //JCT2-A0087
+
 #define SONY_COLPIC_AVAILABILITY          1
 
 #define HHI_INTER_VIEW_MOTION_PRED        1   // inter-view motion parameter prediction
 #define HHI_INTER_VIEW_RESIDUAL_PRED      1   // inter-view residual prediction
-#define HHI_FIX                           1   // inter-view prediction and other fixes
+#define QC_MULTI_DIS_CAN                  1         // JCT2-A0097
+#if QC_MULTI_DIS_CAN
+    #define DIS_CANS                      1
+#endif
+
+#define MTK_INTERVIEW_MERGE_A0049         1 //  JCT2-A0049 second part
+
+#define LGE_DVMCP                         1 //  JCT2-A0126     
+#if LGE_DVMCP
+#define DVFROM_LEFTBELOW                  1
+#define DVFROM_LEFT                       2
+#define DVFROM_ABOVERIGHT                 3
+#define DVFROM_ABOVE                      4
+#define DVFROM_ABOVELEFT                  5
+#define DVFROM_COL                        6
+#endif
+
 
 #define HHI_VSO                           1
-#define HHI_VSO_LS_TABLE                  1
+#define HHI_VSO_LS_TABLE                  1 // m23714
 #define HHI_VSO_DIST_INT                  1
 #define HHI_VSO_SYNTH_DIST_OUT            0
 #define HHI_VSO_COLOR_PLANES              1
+#define HHI_VSO_SPEEDUP_A033              1 // JCT2-A0033 modification 1 (changes classes directly related the renderer model 
+                                            // to are not covered by this define, since nearly the entire class has been changed)
+#define HHI_VSO_RM_ASSERTIONS             0 // output VSO assertions
+#define HHI_VSO_SET_OPTIM                 1 // remove unnecessary updates (works only with HHI_VSO_FIX 1 properly)
+#define SAIT_VSO_EST_A0033                1 // JCT2-A0033 modification 3
+#define LGE_VSO_EARLY_SKIP_A0093          1 // JCT2-A0093 modification 4
+
 
 #define HHI_INTERVIEW_SKIP                1
 #define HHI_INTERVIEW_SKIP_LAMBDA_SCALE   1
 
-#define HHI_DMM_WEDGE_INTRA 1   // depth model modes independent on texture (explicit and intra-predicted Wedgelet prediction)
-#define HHI_DMM_PRED_TEX    1   // depth model modes dependent on texture (inter-component Wedgelet and Contour prediction )
+#define HHI_DMM_WEDGE_INTRA               1   // depth model modes independent on texture (explicit and intra-predicted Wedgelet prediction)
+#define HHI_DMM_PRED_TEX                  1   // depth model modes dependent on texture (inter-component Wedgelet and Contour prediction )
 
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
@@ -224,5 +260,13 @@
 #define LOG2_SCAN_SET_SIZE                4
 
+#if LGE_EDGE_INTRA
+#if LGE_EDGE_INTRA_DELTA_DC
+#define FAST_UDI_MAX_RDMODE_NUM               37          ///< maximum number of RD comparison in fast-UDI estimation loop
+#else
+#define FAST_UDI_MAX_RDMODE_NUM               36          ///< maximum number of RD comparison in fast-UDI estimation loop
+#endif
+#else
 #define FAST_UDI_MAX_RDMODE_NUM               35          ///< maximum number of RD comparison in fast-UDI estimation loop
+#endif
 
 #define ZERO_MVD_EST                          0           ///< Zero Mvd Estimation in normal mode
@@ -263,4 +307,13 @@
 #define NUM_DMM_MODE 4
 #endif
+
+#if LGE_EDGE_INTRA
+#if HHI_DMM_WEDGE_INTRA && HHI_DMM_PRED_TEX
+#define EDGE_INTRA_IDX  (NUM_INTRA_MODE+NUM_DMM_MODE)
+#endif // HHI_DMM_WEDGE_INTRA && HHI_DMM_PRED_TEX
+#if LGE_EDGE_INTRA_DELTA_DC
+#define EDGE_INTRA_DELTA_IDX          (EDGE_INTRA_IDX+1)
+#endif
+#endif // LGE_EDGE_INTRA
 
 #define IBDI_DISTORTION                0           ///< enable/disable SSE modification when IBDI is used (JCTVC-D152)
@@ -647,4 +700,16 @@
 };
 
+#if HHI_VSO_SPEEDUP_A033
+
+enum BlenMod
+{
+    BLEND_NONE  = -1,
+    BLEND_AVRG  = 0,
+    BLEND_LEFT  = 1,
+    BLEND_RIGHT = 2,
+    BLEND_GEN   =  3
+};
+#endif
+
 /// supported prediction type
 enum PredMode
@@ -712,4 +777,15 @@
   DF_HADS16N  = 28,     ///< 16NxM HAD with step
 
+#if SAIT_VSO_EST_A0033
+  DF_VSD      = 29,      ///< general size VSD
+  DF_VSD4     = 30,      ///<   4xM VSD
+  DF_VSD8     = 31,      ///<   8xM VSD
+  DF_VSD16    = 32,      ///<  16xM VSD
+  DF_VSD32    = 33,      ///<  32xM VSD
+  DF_VSD64    = 34,      ///<  64xM VSD
+  DF_VSD16N   = 35,      ///< 16NxM VSD
+#endif
+
+
 #if AMP_SAD
   DF_SAD12    = 43,
Index: trunk/source/Lib/TLibDecoder/TDecCAVLC.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 81)
+++ trunk/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 100)
@@ -1891,9 +1891,5 @@
       rpcSlice->setPOC( iPOCmsb+iPOClsb );
 
-#if HHI_FIX
       if( rpcSlice->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDV && rpcSlice->getPOC() == 0 )
-#else
-      if( rpcSlice->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDV ) 
-#endif
       {
         TComReferencePictureSet* rps = rpcSlice->getLocalRPS();
Index: trunk/source/Lib/TLibDecoder/TDecCu.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecCu.cpp	(revision 81)
+++ trunk/source/Lib/TLibDecoder/TDecCu.cpp	(revision 100)
@@ -643,7 +643,7 @@
     AOF( bOK );
 #if LG_RESTRICTEDRESPRED_M24766
-	Int iPUResiPredShift[4];
-	pcCU->getPUResiPredShift(iPUResiPredShift, 0);
-	m_ppcYuvReco[uiDepth]->add(iPUResiPredShift, pcCU->getPartitionSize(0), m_ppcYuvResPred[uiDepth], pcCU->getWidth( 0 ), pcCU->getHeight( 0 ) );
+    Int iPUResiPredShift[4];
+    pcCU->getPUResiPredShift(iPUResiPredShift, 0);
+    m_ppcYuvReco[uiDepth]->add(iPUResiPredShift, pcCU->getPartitionSize(0), m_ppcYuvResPred[uiDepth], pcCU->getWidth( 0 ), pcCU->getHeight( 0 ) );
 #else
     m_ppcYuvReco[uiDepth]->add( m_ppcYuvResPred[uiDepth], pcCU->getWidth( 0 ), pcCU->getHeight( 0 ) );
@@ -705,4 +705,15 @@
                                      m_pcPrediction->getPredicBufHeight (),
                                      bAboveAvail, bLeftAvail );
+#if LGE_EDGE_INTRA
+  if( uiLumaPredMode >= EDGE_INTRA_IDX )
+  {
+    m_pcPrediction->predIntraLumaEdge( pcCU, pcCU->getPattern(), uiAbsPartIdx, uiWidth, uiHeight, piPred, uiStride
+#if LGE_EDGE_INTRA_DELTA_DC
+      , uiLumaPredMode == EDGE_INTRA_DELTA_IDX
+#endif
+      );
+  } 
+  else
+#endif
   
   //===== get prediction signal =====
Index: trunk/source/Lib/TLibDecoder/TDecGop.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecGop.cpp	(revision 81)
+++ trunk/source/Lib/TLibDecoder/TDecGop.cpp	(revision 100)
@@ -303,5 +303,7 @@
     {
       m_pcDepthMapGenerator->initViewComponent( rpcPic );
+#if !QC_MULTI_DIS_CAN
       m_pcDepthMapGenerator->predictDepthMap  ( rpcPic );
+#endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
       m_pcResidualGenerator->initViewComponent( rpcPic );
@@ -339,6 +341,8 @@
 #endif
 #if DEPTH_MAP_GENERATION
+#if !QC_MULTI_DIS_CAN
     // update virtual depth map
     m_pcDepthMapGenerator->updateDepthMap( rpcPic );
+#endif
 #endif
     // deblocking filter
Index: trunk/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 81)
+++ trunk/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 100)
@@ -98,4 +98,10 @@
 , m_cDmmDataSCModel           ( 1,             1,               NUM_DMM_DATA_CTX              , m_contextModels + m_numContextModels, m_numContextModels)
 #endif
+#if LGE_EDGE_INTRA
+, m_cEdgeIntraSCModel         ( 1,             1,               NUM_EDGE_INTRA_CTX            , m_contextModels + m_numContextModels, m_numContextModels)
+#if LGE_EDGE_INTRA_DELTA_DC
+, m_cEdgeIntraDeltaDCSCModel  ( 1,             1,               NUM_EDGE_INTRA_DELTA_DC_CTX   , m_contextModels + m_numContextModels, m_numContextModels)
+#endif
+#endif
 {
   assert( m_numContextModels <= MAX_NUM_CTX_MOD );
@@ -182,4 +188,10 @@
 
   m_cCUTransSubdivFlagSCModel.initBuffer ( sliceType, qp, (UChar*)INIT_TRANS_SUBDIV_FLAG );
+#if LGE_EDGE_INTRA
+  m_cEdgeIntraSCModel.initBuffer         ( sliceType, qp, (UChar*)INIT_EDGE_INTRA );
+#if LGE_EDGE_INTRA_DELTA_DC
+  m_cEdgeIntraDeltaDCSCModel.initBuffer  ( sliceType, qp, (UChar*)INIT_EDGE_INTRA_DELTA_DC );
+#endif
+#endif
   m_uiLastDQpNonZero  = 0;
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
@@ -815,5 +827,5 @@
   {
     UInt uiDMMode;
-  
+
 #if HHI_DMM_WEDGE_INTRA && HHI_DMM_PRED_TEX
     m_pcTDecBinIf->decodeBin( uiSymbol, m_cDmmModeSCModel.get(0, 0, 0) ); uiDMMode  = uiSymbol;
@@ -847,69 +859,141 @@
 #endif
 #if !LOGI_INTRA_NAME_3MPM
-  Int iIntraIdx = pcCU->getIntraSizeIdx(uiAbsPartIdx);
-#endif
-  
+    Int iIntraIdx = pcCU->getIntraSizeIdx(uiAbsPartIdx);
+#endif
+
+#if LGE_EDGE_INTRA
+    Bool bCodeEdgeIntra = false;
+    if( pcCU->getSlice()->getSPS()->isDepth() )
+    {
+      UInt uiPUWidth = pcCU->getWidth( uiAbsPartIdx ) >> (pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_NxN ? 1 : 0);
+      if( uiPUWidth <= LGE_EDGE_INTRA_MAX_SIZE && uiPUWidth >= LGE_EDGE_INTRA_MIN_SIZE )
+        bCodeEdgeIntra = true;
+    }
+#endif
+
 #if LOGI_INTRA_NAME_3MPM
-  Int uiPreds[3] = {-1, -1, -1};
-#else
-  Int uiPreds[2] = {-1, -1};
-#endif
-  Int uiPredNum = pcCU->getIntraDirLumaPredictor(uiAbsPartIdx, uiPreds);  
- 
-  m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUIntraPredSCModel.get( 0, 0, 0) );
- 
-  if ( uiSymbol )
-  {
-    m_pcTDecBinIf->decodeBinEP( uiSymbol );
+    Int uiPreds[3] = {-1, -1, -1};
+#else
+    Int uiPreds[2] = {-1, -1};
+#endif
+    Int uiPredNum = pcCU->getIntraDirLumaPredictor(uiAbsPartIdx, uiPreds);  
+#if LGE_EDGE_INTRA
+    UInt uiCheckBit = 0;
+#endif
+
+    m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUIntraPredSCModel.get( 0, 0, 0) );
+
+    if ( uiSymbol )
+    {
+      m_pcTDecBinIf->decodeBinEP( uiSymbol );
 #if LOGI_INTRA_NAME_3MPM
-    if (uiSymbol)
-    {
-      m_pcTDecBinIf->decodeBinEP( uiSymbol );
-      uiSymbol++;
-    }
-#endif
-    intraPredMode = uiPreds[uiSymbol];
-  }
-  else
-  {
-    intraPredMode = 0;
-    
+      if (uiSymbol)
+      {
+        m_pcTDecBinIf->decodeBinEP( uiSymbol );
+        uiSymbol++;
+      }
+#endif
+      intraPredMode = uiPreds[uiSymbol];
+    }
+    else
+    {
+      intraPredMode = 0;
+
 #if LOGI_INTRA_NAME_3MPM
-   
-    m_pcTDecBinIf->decodeBinsEP( uiSymbol, 5 );
-    intraPredMode = uiSymbol;
-    
-   //postponed sorting of MPMs (only in remaining branch)
-    if (uiPreds[0] > uiPreds[1])
-    { 
-      std::swap(uiPreds[0], uiPreds[1]); 
-    }
-    if (uiPreds[0] > uiPreds[2])
-    {
-      std::swap(uiPreds[0], uiPreds[2]);
-    }
-    if (uiPreds[1] > uiPreds[2])
-    {
-      std::swap(uiPreds[1], uiPreds[2]);
-    }
-#else
-    m_pcTDecBinIf->decodeBinsEP( uiSymbol, g_aucIntraModeBitsAng[iIntraIdx] - 1 );
-    intraPredMode = uiSymbol;
-    
-    if ( intraPredMode == 31 )
-    {
-      m_pcTDecBinIf->decodeBinEP( uiSymbol );
-      intraPredMode += uiSymbol;      
-    }
-#endif
-    for ( Int i = 0; i < uiPredNum; i++ )
-    {
-      intraPredMode += ( intraPredMode >= uiPreds[i] );
-    }
-  }
+
+      m_pcTDecBinIf->decodeBinsEP( uiSymbol, 5 );
+#if LGE_EDGE_INTRA
+      if (bCodeEdgeIntra)
+      {
+        if (uiSymbol==31)
+        {
+          m_pcTDecBinIf->decodeBinsEP(uiCheckBit,1);
+          if (uiCheckBit)
+            uiSymbol = EDGE_INTRA_IDX;
+        }
+      }
+#endif
+      intraPredMode = uiSymbol;
+
+      //postponed sorting of MPMs (only in remaining branch)
+      if (uiPreds[0] > uiPreds[1])
+      { 
+        std::swap(uiPreds[0], uiPreds[1]); 
+      }
+      if (uiPreds[0] > uiPreds[2])
+      {
+        std::swap(uiPreds[0], uiPreds[2]);
+      }
+      if (uiPreds[1] > uiPreds[2])
+      {
+        std::swap(uiPreds[1], uiPreds[2]);
+      }
+#else
+      m_pcTDecBinIf->decodeBinsEP( uiSymbol, g_aucIntraModeBitsAng[iIntraIdx] - 1 );
+      intraPredMode = uiSymbol;
+
+      if ( intraPredMode == 31 )
+      {
+        m_pcTDecBinIf->decodeBinEP( uiSymbol );
+        intraPredMode += uiSymbol;      
+      }
+#endif
+#if LGE_EDGE_INTRA
+      if ( intraPredMode != EDGE_INTRA_IDX)
+      {
+#endif
+        for ( Int i = 0; i < uiPredNum; i++ )
+        {
+          intraPredMode += ( intraPredMode >= uiPreds[i] );
+        }
+#if LGE_EDGE_INTRA
+      }
+#endif
+    }
+
+#if LGE_EDGE_INTRA
+    if( intraPredMode == EDGE_INTRA_IDX )
+    {
+      xParseEdgeIntraInfo( pcCU, uiAbsPartIdx, uiDepth );
+#if LGE_EDGE_INTRA_DELTA_DC
+      m_pcTDecBinIf->decodeBin( uiSymbol, m_cEdgeIntraDeltaDCSCModel.get(0, 0, 0) );
+      if( uiSymbol )
+      {
+        intraPredMode = EDGE_INTRA_DELTA_IDX;
+        Int iDeltaDC0;
+        Int iDeltaDC1;
+
+        xReadExGolombLevel( (UInt &) iDeltaDC0, m_cEdgeIntraDeltaDCSCModel.get(0, 0, 1) );
+        if( iDeltaDC0 != 0 )
+        {
+          UInt uiSign;
+          m_pcTDecBinIf->decodeBinEP( uiSign );
+          if ( uiSign )
+          {
+            iDeltaDC0 = -iDeltaDC0;
+          }
+        }
+        xReadExGolombLevel( (UInt &) iDeltaDC1, m_cEdgeIntraDeltaDCSCModel.get(0, 0, 1) );
+        if( iDeltaDC1 != 0 )
+        {
+          UInt uiSign;
+          m_pcTDecBinIf->decodeBinEP( uiSign );
+          if ( uiSign )
+          {
+            iDeltaDC1 = -iDeltaDC1;
+          }
+        }
+
+        pcCU->setEdgeDeltaDC0( uiAbsPartIdx, iDeltaDC0 );
+        pcCU->setEdgeDeltaDC1( uiAbsPartIdx, iDeltaDC1 );
+      }
+#endif
+    }
+#endif
+
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
   }
 #endif
-  
+
   pcCU->setLumaIntraDirSubParts( (UChar)intraPredMode, uiAbsPartIdx, uiDepth );
 }
@@ -2012,5 +2096,5 @@
 #endif
 
-#if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
+#if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX || (LGE_EDGE_INTRA && LGE_EDGE_INTRA_DELTA_DC)
 Void TDecSbac::xReadExGolombLevel( UInt& ruiSymbol, ContextModel& rcSCModel  )
 {
@@ -2270,3 +2354,102 @@
 }
 #endif
+
+#if LGE_EDGE_INTRA
+Void TDecSbac::xParseEdgeIntraInfo( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
+{
+  UInt uiSymbol = 0;
+
+  // 1. Top(0) or Left(1)
+  UChar ucLeft;
+  m_pcTDecBinIf->decodeBinEP( uiSymbol );
+  ucLeft = uiSymbol;
+
+  // 2. Start position (lowest bit first)
+  UChar ucStart = 0;
+  for( UInt ui = 0; ui < 6 - uiDepth; ui++ )
+  {
+    m_pcTDecBinIf->decodeBinEP( uiSymbol );
+    ucStart |= (uiSymbol << ui);
+  }
+
+  // 3. Number of edges
+  UChar ucMax = 0;
+  for( UInt ui = 0; ui < 7 - uiDepth; ui++ )
+  {
+    m_pcTDecBinIf->decodeBinEP( uiSymbol );
+    ucMax |= (uiSymbol << ui);
+  }
+  ucMax++; // +1
+
+  // 4. Edges
+  UChar* pucSymbolList = (UChar*) xMalloc( UChar, 256 * LGE_EDGE_INTRA_MAX_EDGE_NUM_PER_4x4 );
+  UInt uiCtxEdgeIntra = pcCU->getCtxEdgeIntra( uiAbsPartIdx );
+  for( Int iPtr = 0; iPtr < ucMax; iPtr++ )
+  {
+    UChar ucEdge = 0;
+    UInt  uiReorderEdge = 0;
+    // Left-friendly direction
+    // 0 (   0deg) => 0
+    // 1 (  45deg) => 10
+    // 2 ( -45deg) => 110
+    // 3 (  90deg) => 1110
+    // 4 ( -90deg) => 11110
+    // 5 ( 135deg) => 111110
+    // 6 (-135deg) => 111111
+    // Right-friendly direction
+    // 0 (   0deg) => 0
+    // 1 ( -45deg) => 10
+    // 2 (  45deg) => 110
+    // 3 ( -90deg) => 1110
+    // 4 (  90deg) => 11110
+    // 5 (-135deg) => 111110
+    // 6 ( 135deg) => 111111
+    // refer to a paper "An efficient chain code with Huffman coding"
+    for( UInt ui = 0; ui < 6; ui++ )
+    {
+      m_pcTDecBinIf->decodeBin( uiSymbol, m_cEdgeIntraSCModel.get( 0, 0, uiCtxEdgeIntra ) );
+      ucEdge <<= 1;
+      ucEdge |= uiSymbol;
+      if( uiSymbol == 0 )
+        break;
+    }
+
+    switch( ucEdge )
+    {
+    case 0 :  // "0"
+      uiReorderEdge = 0;
+      break;
+    case 2 :  // "10"
+      uiReorderEdge = 1;
+      break;
+    case 6 :  // "110"
+      uiReorderEdge = 2;
+      break;
+    case 14 : // "1110"
+      uiReorderEdge = 3;
+      break;
+    case 30 : // "11110"
+      uiReorderEdge = 4;
+      break;
+    case 62 : // "111110"
+      uiReorderEdge = 5;
+      break;
+    case 63 : // "111111"
+      uiReorderEdge = 6;
+      break;
+    default :
+      printf("parseIntraEdgeChain: error (unknown code %d)\n",ucEdge);
+      assert(false);
+      break;
+    }
+    pucSymbolList[iPtr] = uiReorderEdge;
+  }
+  /////////////////////
+  // Edge Reconstruction
+  Bool* pbRegion = pcCU->getEdgePartition( uiAbsPartIdx );
+  pcCU->reconPartition( uiAbsPartIdx, uiDepth, ucLeft == 1, ucStart, ucMax, pucSymbolList, pbRegion );
+  xFree( pucSymbolList );
+}
+#endif
+
 //! \}
Index: trunk/source/Lib/TLibDecoder/TDecSbac.h
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecSbac.h	(revision 81)
+++ trunk/source/Lib/TLibDecoder/TDecSbac.h	(revision 100)
@@ -146,4 +146,8 @@
 #endif
   
+#if LGE_EDGE_INTRA
+  Void xParseEdgeIntraInfo ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
+#endif
+  
 private:
   TComInputBitstream* m_pcBitstream;
@@ -253,4 +257,10 @@
   ContextModel3DBuffer m_cDmmDataSCModel;
 #endif
+#if LGE_EDGE_INTRA
+  ContextModel3DBuffer m_cEdgeIntraSCModel;
+#if LGE_EDGE_INTRA_DELTA_DC
+  ContextModel3DBuffer m_cEdgeIntraDeltaDCSCModel;
+#endif
+#endif
 };
 
Index: trunk/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 81)
+++ trunk/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 100)
@@ -378,5 +378,5 @@
 Void TEncCavlc::codeVPS( TComVPS* pcVPS )
 {
-	WRITE_CODE( pcVPS->getMaxTLayers() - 1,     3,        "max_temporal_layers_minus1" );
+  WRITE_CODE( pcVPS->getMaxTLayers() - 1,     3,        "max_temporal_layers_minus1" );
   WRITE_CODE( pcVPS->getMaxLayers() - 1,      5,        "max_layers_minus1" );
   WRITE_FLAG( pcVPS->getTemporalNestingFlag() - 1,      "temporal_id_nesting_flag" );
@@ -775,5 +775,4 @@
     {
       WRITE_CODE( (pcSlice->getPOC()-pcSlice->getLastIDR()+(1<<pcSlice->getSPS()->getBitsForPOC()))%(1<<pcSlice->getSPS()->getBitsForPOC()), pcSlice->getSPS()->getBitsForPOC(), "pic_order_cnt_lsb");
-#if HHI_FIX
       if( pcSlice->getPOC() == 0 && pcSlice->getNalUnitType() != NAL_UNIT_CODED_SLICE_IDV )
       {
@@ -848,7 +847,4 @@
       }
       if( pcSlice->getPOC() != 0 )
-#else
-      if( pcSlice->getNalUnitType() != NAL_UNIT_CODED_SLICE_IDV )
-#endif
       {
         TComReferencePictureSet* rps = pcSlice->getRPS();
Index: trunk/source/Lib/TLibEncoder/TEncCfg.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncCfg.h	(revision 81)
+++ trunk/source/Lib/TLibEncoder/TEncCfg.h	(revision 100)
@@ -205,4 +205,9 @@
   UInt      m_uiVSOMode;
 #endif
+#if SAIT_VSO_EST_A0033
+  Bool      m_bUseEstimatedVSD; 
+  Double    m_dDispCoeff;
+#endif
+
 
   //====== Tool list ========
@@ -568,4 +573,9 @@
 #endif
 
+#if SAIT_VSO_EST_A0033
+  Void      setUseEstimatedVSD              ( Bool  b )     { m_bUseEstimatedVSD = b; }
+  Void      setDispCoeff                    ( Double  d )   { m_dDispCoeff  = d; }
+#endif
+
   Void      setUseFastEnc                   ( Bool  b )     { m_bUseFastEnc = b; }
   Void      setUseEarlyCU                   ( Bool  b )     { m_bUseEarlyCU = b; }
@@ -608,4 +618,9 @@
   Bool      getUseVSO                       ()      { return m_bUseVSO;     }
 #endif
+#if SAIT_VSO_EST_A0033
+  Bool      getUseEstimatedVSD              ()      { return m_bUseEstimatedVSD; }
+  Double    getDispCoeff                    ()      { return m_dDispCoeff;    }
+#endif
+
   Bool      getUseFastEnc                   ()      { return m_bUseFastEnc; }
   Bool      getUseEarlyCU                   ()      { return m_bUseEarlyCU; }
Index: trunk/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncCu.cpp	(revision 81)
+++ trunk/source/Lib/TLibEncoder/TEncCu.cpp	(revision 100)
@@ -1156,5 +1156,4 @@
       if( m_pcRdCost->getUseRenModel() )
       {
-#if HHI_FIX
         UInt  uiWidth     = m_ppcOrigYuv[uiDepth]->getWidth ( );
         UInt  uiHeight    = m_ppcOrigYuv[uiDepth]->getHeight( );
@@ -1162,11 +1161,4 @@
         UInt  uiSrcStride = m_ppcOrigYuv[uiDepth]->getStride();
         m_pcRdCost->setRenModelData( m_ppcBestCU[uiDepth], 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#else
-        UInt  uiWidth     = m_ppcBestCU[uiDepth]->getWidth ( 0 );
-        UInt  uiHeight    = m_ppcBestCU[uiDepth]->getHeight( 0 );
-        Pel*  piSrc       = m_ppcOrigYuv[uiDepth]->getLumaAddr( 0 );
-        UInt  uiSrcStride = m_ppcOrigYuv[uiDepth]->getStride();
-        m_pcRdCost->setRenModelData( m_ppcBestCU[uiDepth], 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#endif
       }
 #endif
@@ -1212,7 +1204,8 @@
 
 #if HHI_VSO
+#if HHI_VSO_SET_OPTIM 
+#else 
           if( m_pcRdCost->getUseRenModel() ) // necessary ??
           {
-#if HHI_FIX
             UInt  uiWidth     = m_ppcRecoYuvBest[uhNextDepth]->getWidth   (  );
             UInt  uiHeight    = m_ppcRecoYuvBest[uhNextDepth]->getHeight  (   );
@@ -1220,12 +1213,6 @@
             UInt  uiSrcStride = m_ppcRecoYuvBest[uhNextDepth]->getStride  (   );
             m_pcRdCost->setRenModelData( pcSubBestPartCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#else
-            UInt  uiWidth     = pcSubBestPartCU->getWidth ( 0 );
-            UInt  uiHeight    = pcSubBestPartCU->getHeight( 0 );
-            Pel*  piSrc       = m_ppcRecoYuvBest[pcSubBestPartCU->getDepth(0)]->getLumaAddr( 0 );
-            UInt  uiSrcStride = m_ppcRecoYuvBest[pcSubBestPartCU->getDepth(0)]->getStride();
-            m_pcRdCost->setRenModelData( pcSubBestPartCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#endif
-          }
+          }
+#endif
 #endif
         }
@@ -1369,5 +1356,4 @@
   if( m_pcRdCost->getUseRenModel() )
   {
-#if HHI_FIX
       UInt  uiWidth     = m_ppcRecoYuvBest[uiDepth]->getWidth   ( );
       UInt  uiHeight    = m_ppcRecoYuvBest[uiDepth]->getHeight  ( );
@@ -1375,11 +1361,4 @@
       UInt  uiSrcStride = m_ppcRecoYuvBest[uiDepth]->getStride  ( );
       m_pcRdCost->setRenModelData( rpcBestCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#else
-    UInt  uiWidth     = rpcBestCU->getWidth ( 0 );
-    UInt  uiHeight    = rpcBestCU->getHeight( 0 );
-    Pel*  piSrc       = m_ppcRecoYuvBest[uiDepth]->getLumaAddr( 0 );
-    UInt  uiSrcStride = m_ppcRecoYuvBest[uiDepth]->getStride();
-    m_pcRdCost->setRenModelData( rpcBestCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#endif
   }
 #endif
@@ -1747,5 +1726,4 @@
   if( m_pcRdCost->getUseRenModel() )
   {
-#if HHI_FIX
     UInt  uiWidth     = m_ppcOrigYuv[uhDepth]->getWidth ( );
     UInt  uiHeight    = m_ppcOrigYuv[uhDepth]->getHeight( );
@@ -1753,11 +1731,4 @@
     UInt  uiSrcStride = m_ppcOrigYuv[uhDepth]->getStride();
     m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#else
-    UInt  uiWidth     = rpcTempCU->getWidth ( 0 );
-    UInt  uiHeight    = rpcTempCU->getHeight( 0 );
-    Pel*  piSrc       = m_ppcOrigYuv[uhDepth]->getLumaAddr( );
-    UInt  uiSrcStride = m_ppcOrigYuv[uhDepth]->getStride();
-    m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#endif
   }
 #endif
@@ -1851,5 +1822,4 @@
           if( m_pcRdCost->getUseRenModel() )
           { //Reset
-#if HHI_FIX
             UInt  uiWidth     = m_ppcOrigYuv[uhDepth]->getWidth    ();
             UInt  uiHeight    = m_ppcOrigYuv[uhDepth]->getHeight   ();
@@ -1857,11 +1827,4 @@
             UInt  uiSrcStride = m_ppcOrigYuv[uhDepth]->getStride   ();
             m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#else
-            UInt  uiWidth     = rpcTempCU->getWidth ( 0 );
-            UInt  uiHeight    = rpcTempCU->getHeight( 0 );
-            Pel*  piSrc       = m_ppcOrigYuv[uhDepth]->getLumaAddr( );
-            UInt  uiSrcStride = m_ppcOrigYuv[uhDepth]->getStride();
-            m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#endif
           }
 #endif
@@ -1927,5 +1890,4 @@
   if( m_pcRdCost->getUseRenModel() )
   {
-#if HHI_FIX
     UInt  uiWidth     = m_ppcOrigYuv[uhDepth]->getWidth ( );
     UInt  uiHeight    = m_ppcOrigYuv[uhDepth]->getHeight( );
@@ -1933,11 +1895,4 @@
     UInt  uiSrcStride = m_ppcOrigYuv[uhDepth]->getStride();
     m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#else
-    UInt  uiWidth     = rpcTempCU->getWidth ( 0 );
-    UInt  uiHeight    = rpcTempCU->getHeight( 0 );
-    Pel*  piSrc       = m_ppcOrigYuv[uhDepth]->getLumaAddr( );
-    UInt  uiSrcStride = m_ppcOrigYuv[uhDepth]->getStride();
-    m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#endif
   }
 #endif  
@@ -2046,5 +2001,4 @@
   if( m_pcRdCost->getUseRenModel() )
   {
-#if HHI_FIX
     UInt  uiWidth     = m_ppcOrigYuv[uiDepth]->getWidth   ();
     UInt  uiHeight    = m_ppcOrigYuv[uiDepth]->getHeight  ();
@@ -2052,11 +2006,4 @@
     UInt  uiSrcStride = m_ppcOrigYuv[uiDepth]->getStride  ();
     m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#else
-    UInt  uiWidth     = rpcTempCU->getWidth ( 0 );
-    UInt  uiHeight    = rpcTempCU->getHeight( 0 );
-    Pel*  piSrc       = m_ppcOrigYuv[uiDepth]->getLumaAddr( );
-    UInt  uiSrcStride = m_ppcOrigYuv[uiDepth]->getStride();
-    m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#endif
   }
 #endif
@@ -2557,5 +2504,4 @@
   if( m_pcRdCost->getUseRenModel() && !bRecursiveCall)
   {
-#if HHI_FIX
     UInt  uiWidth     = m_ppcOrigYuv[uhDepth]->getWidth   ();
     UInt  uiHeight    = m_ppcOrigYuv[uhDepth]->getHeight  ();
@@ -2563,11 +2509,4 @@
     UInt  uiSrcStride = m_ppcOrigYuv[uhDepth]->getStride  ();
     m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#else
-    UInt  uiWidth     = m_ppcTempCU [uhDepth]->getWidth ( 0 );
-    UInt  uiHeight    = m_ppcTempCU [uhDepth]->getHeight( 0 );
-    Pel*  piSrc       = m_ppcOrigYuv[uhDepth]->getLumaAddr( 0 );
-    UInt  uiSrcStride = m_ppcOrigYuv[uhDepth]->getStride();
-    m_pcRdCost->setRenModelData( m_ppcTempCU[uhDepth], 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#endif
   }
 #endif
@@ -2717,5 +2656,4 @@
   if( !bSplit && bRecursiveCall && m_pcRdCost->getUseRenModel() )
   {
-#if HHI_FIX
     UInt  uiWidth     = m_ppcRecoYuvBest[uhDepth]->getWidth   (   );
     UInt  uiHeight    = m_ppcRecoYuvBest[uhDepth]->getHeight  (   );
@@ -2723,11 +2661,4 @@
     Pel*  piSrc       = m_ppcRecoYuvBest[uhDepth]->getLumaAddr( 0 );
     m_pcRdCost->setRenModelData( rpcBestCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#else
-    UInt  uiWidth     = rpcBestCU->getWidth ( 0 );
-    UInt  uiHeight    = rpcBestCU->getHeight( 0 );
-    Pel*  piSrc       = m_ppcRecoYuvBest[uhDepth]->getLumaAddr( 0 );
-    UInt  uiSrcStride = m_ppcRecoYuvBest[uhDepth]->getStride();
-    m_pcRdCost->setRenModelData( rpcBestCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-#endif
   }
 #endif
Index: trunk/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 81)
+++ trunk/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 100)
@@ -436,4 +436,7 @@
   Bool bUseVSO = m_pcEncTop->getUseVSO();
   m_pcRdCost->setUseVSO( bUseVSO );
+#if SAIT_VSO_EST_A0033
+  m_pcRdCost->setUseEstimatedVSD( m_pcEncTop->getUseEstimatedVSD() );
+#endif
 
   if ( bUseVSO )
@@ -445,4 +448,6 @@
 #endif
 
+#if HHI_VSO_SPEEDUP_A033
+#else
     if ( iVSOMode == 4 )
     {
@@ -453,4 +458,12 @@
       AOT(true); 
     }
+#endif
+
+#if SAIT_VSO_EST_A0033
+    m_pcRdCost->setVideoRecPicYuv( m_pcEncTop->getEncTop()->xGetPicYuvFromViewTemp( pcSlice->getViewId(), pcSlice->getPOC(), false, true ) );
+    m_pcRdCost->setDepthPicYuv   ( m_pcEncTop->getEncTop()->xGetPicYuvFromViewTemp( pcSlice->getViewId(), pcSlice->getPOC(), true, false ) );
+#endif
+
+
   }
 #endif
@@ -691,5 +704,7 @@
       // init view component and predict virtual depth map
       m_pcDepthMapGenerator->initViewComponent( pcPic );
+#if !QC_MULTI_DIS_CAN
       m_pcDepthMapGenerator->predictDepthMap  ( pcPic );
+#endif
 #endif
 #if HHI_INTER_VIEW_MOTION_PRED
@@ -758,6 +773,8 @@
 #endif
 #if DEPTH_MAP_GENERATION
+#if !QC_MULTI_DIS_CAN
       // update virtual depth map
       m_pcDepthMapGenerator->updateDepthMap( pcPic );
+#endif
 #endif
 
@@ -2475,18 +2492,18 @@
     if( hasModification )
     {
-	    Int temporalRefIdx = 0;
-	    for( Int i = 0; i < pcSlice->getNumRefIdx( REF_PIC_LIST_0 ); i++ )
-	    {
-	      if( tempListEntryL0[i] >= 0 ) 
-	      {
-	        refPicListModification->setRefPicSetIdxL0( i, tempListEntryL0[i] );
-	      }
-	      else
-	      {
-	        refPicListModification->setRefPicSetIdxL0( i, temporalRefIdx );
-	        temporalRefIdx++;
-	      }
-	    }
-	  }
+      Int temporalRefIdx = 0;
+      for( Int i = 0; i < pcSlice->getNumRefIdx( REF_PIC_LIST_0 ); i++ )
+      {
+        if( tempListEntryL0[i] >= 0 ) 
+        {
+          refPicListModification->setRefPicSetIdxL0( i, tempListEntryL0[i] );
+        }
+        else
+        {
+          refPicListModification->setRefPicSetIdxL0( i, temporalRefIdx );
+          temporalRefIdx++;
+        }
+      }
+    }
     else
     {
@@ -2520,17 +2537,17 @@
     if( hasModification )
     {
-	    Int temporalRefIdx = 0;
-	    for( Int i = 0; i < pcSlice->getNumRefIdx( REF_PIC_LIST_1 ); i++ )
-	    {
-	      if( tempListEntryL1[i] >= 0 ) 
-	      {
-	        refPicListModification->setRefPicSetIdxL1( i, tempListEntryL1[i] );
-	      }
-	      else
-	      {
-	        refPicListModification->setRefPicSetIdxL1( i, temporalRefIdx );
-	        temporalRefIdx++;
-	      }
-	    }
+      Int temporalRefIdx = 0;
+      for( Int i = 0; i < pcSlice->getNumRefIdx( REF_PIC_LIST_1 ); i++ )
+      {
+        if( tempListEntryL1[i] >= 0 ) 
+        {
+          refPicListModification->setRefPicSetIdxL1( i, tempListEntryL1[i] );
+        }
+        else
+        {
+          refPicListModification->setRefPicSetIdxL1( i, temporalRefIdx );
+          temporalRefIdx++;
+        }
+      }
     } 
     else
Index: trunk/source/Lib/TLibEncoder/TEncGOP.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncGOP.h	(revision 81)
+++ trunk/source/Lib/TLibEncoder/TEncGOP.h	(revision 100)
@@ -137,4 +137,7 @@
   
   Void  preLoopFilterPicAll  ( TComPic* pcPic, UInt64& ruiDist, UInt64& ruiBits );
+#if HHI_VSO_SPEEDUP_A033
+  TEncTop* getEncTop() { return m_pcEncTop; }
+#endif
   
   TEncSlice*  getSliceEncoder()   { return m_pcSliceEncoder; }
